/****************************************************************

COPYRIGHT (C) 1992 UNIVERSITY OF CALIFORNIA

***************************************************************/

conv_ds(x1, x2, h, m, nrow, ncol, flag)
int nrow, ncol, m, flag;
float *x1, **x2, *h;
{
    *x2 = (float*)malloc((nrow*ncol/2)*sizeof(float));
    conv_rows(x1, x2, h, m, nrow, ncol, flag);
    tpose(x2, nrow, ncol/2);
}

/****************************************************************/

conv_rows(x1, x2, h, m, nrow, ncol, flag)
int nrow, ncol, m, flag;
float *x1, **x2, *h;
{
    float *max, *x2ptr;

    x2ptr = *x2;
    max = x1 + nrow*ncol;
    while(x1 < max) {
        if(!flag)
            conv_ds_lp_rbc(x1, x2ptr, h, m, ncol);
        else
            conv_ds_hp_rbc(x1, x2ptr, h, m, ncol);
        x1 += ncol;
        x2ptr += ncol/2;
    }
}
